//
//  P4Message.m
//  Pulse
//
//  Created by Matt Attaway on 2/16/14.
//  Copyright (c) 2014 Zen of the Monkey. All rights reserved.
//

#import "P4Message.h"

@implementation P4Message

- (id) init
{
    self = [super init];
    
    if(self)
    {
        self.results = [[NSMutableDictionary alloc] init];
        self.list = [[NSMutableArray alloc] init];
    }
    
    return self;
}


- (id) initWithError:(NSString *)msg
{
    self = [super init];
    
    if(self)
    {
        self.results = [[NSMutableDictionary alloc] init];
        self.list = [[NSMutableArray alloc] init];
        self.error = msg;
    }
    
    return self;
}


- (BOOL) isLoginError
{
    BOOL loginError = false;
    
    if(!self.error)
    {
        return false;
    }
    
    if([self.error isEqual:@"Your session has expired, please login again.\n"] ||
       [self.error isEqual:@"Perforce password (P4PASSWD) invalid or unset.\n"] )
    {
        loginError = true;
    }
    
    return loginError;
}


- (BOOL) isUnicodeError
{
    BOOL unicodeError = false;
    
    if(!self.error)
    {
        return false;
    }
    
    if ([self.error isEqual:@"Unicode server permits only unicode enabled clients.\n"] ||
        [self.error isEqual:@"Unicode clients require a unicode enabled server.\n"] )
    {
        unicodeError = true;
    }
    
    return unicodeError;
}


- (BOOL)isConnectionError
{
    BOOL connectionError = false;
    
    if(!self.error)
    {
        return false;
    }
    
    if([self.error rangeOfString:@"Connect to server failed"].location != NSNotFound)
    {
        connectionError = true;
    }
    
    return connectionError;
}

@end
